# IRnLibrary Interface Reference

Inherits IUnknown.

List of all members.

## Methods
RtBool * | CustomLibraryBitmap`[get]`
RtBool | CustomLibraryBitmap`[set]`
RtUlong * | GroupId`[get]`
RtUlong | GroupId`[set]`
HRESULT | GetBitmapSize ([in] RtBool bPreview3D,[in] HDC hDC,[out] RtShort *psWidth,[out] RtShort *psHeight)
HRESULT | GetSubLibrary ([in] RtUlong nIndex,[out, retval] IRnLibrary **pLibrary)
HRESULT | GetLibraryItem ([in] RtUlong nIndex,[out] IRnLibraryItem **pLibraryItem)
HRESULT | GetLibrariesHeight ([out, retval] RtUlong *pVal)
HRESULT | AddItem ([in] IRsNode *pNode,[out, retval] IRnLibraryItem **lppItem)
HRESULT | AddLibrary ([in] IRnLibrary *pLibrary,[out, retval] IRnLibrary **lppLibrary)
HRESULT | ChangeLibraryIndex ([in, out] RtUlong *index,[in] IRnLibrary *lpLibrary)
HRESULT | ChangeLibraryItemIndex ([in, out] RtUlong *index,[in] IRnLibraryItem *lpLibraryItem)
HRESULT | GetCorrectLibraryItemName ([in] IRnLibraryItem *libraryItem,[in] BSTR oldName,[out, retval] BSTR *newName)
HRESULT | CorrectLibraryItemName ([in] IRnLibraryItem *libraryItem,[out, retval] BSTR *newName)
HRESULT | SetAndSaveLocalSave ([in] RtBool bLocalSave)
HRESULT | RestoreAfterExport (void)
HRESULT | PrepareForExport (void)
HRESULT | RestoreLocalSave (void)
HRESULT | StoreCurrentName (void)
HRESULT | ExportLibraryToFile ([in] BSTR bszFileName,[in]RtBool bSaveItems)
HRESULT | CanBeLocal ([out] RtBool *pResult)
HRESULT | PrepareItemsBeforeExport ([in] RtBool bSaveItems)
HRESULT | RestoreItemsAfterExport ([in] RtBool bSaveItems)
HRESULT | EnsureItemsPresence (void)
HRESULT | SaveAsLocal (void)
HRESULT | OnDeleteLibrary (void)
HRESULT | NameExists ([in] BSTR nameToCheck,[out] IRnLibrary **foundLibrary,[out] IRnLibraryItem **foundLibraryItem)
## Properties
Properties
BSTR * | Name`[get]`
BSTR | Name`[set]`
BSTR * | HelpText`[get]`
BSTR | HelpText`[set]`
HBITMAP * | Bitmap ([in] HDC hDC,[in] RtBool bPreview3D)`[get]`
RtUlong * | Index`[get]`
RtUlong | Index`[set]`
RtUlong | ForcedIndex`[set]`
RtUlong * | NumOfItems`[get]`
RtUlong | NumOfItems`[set]`
RtUlong * | NumOfSubLibraries`[get]`
RtUlong * | NumOfLibraryItems`[get]`
RtLibraryType * | Type`[get]`
RtLibraryType | Type`[set]`
RtUlong * | LocalFlag`[get]`
RtUlong | LocalFlag`[set]`
BSTR * | LocalFileName`[get]`
BSTR | LocalFileName`[set]`
BSTR * | LocalPositionInGraph`[get]`
BSTR | LocalPositionInGraph`[set]`
IRdBitmap ** | BmpObj`[get]`
IRdBitmap * | BmpObj`[set]`
IRdBitmap ** | SmallBmpObj`[get]`
IRdBitmap * | SmallBmpObj`[set]`
BSTR * | ExportFileName`[get]`
RtBool * | IsPerformingLocalSaveOperations`[get]`

## Detailed Description

Library node itnerface:

## Member Function Documentation

HRESULT IRnLibrary::GetBitmapSize | ( | [in] RtBool | bPreview3D,
|  | [in] HDC | hDC,
|  | [out] RtShort * | psWidth,
|  | [out] RtShort * | psHeight |
| ) |  |  |

Retrieves bounding rectangle around item image.

Parameters:

  | bPreview3D | [In] Flag to retrieve preview for 2D or 3D aspect.
  | hDC | [In] Handle of device content, may be NULL.
  | psWidth | [Out] Pointer to buffer for text width.
  | psHeight | [Out] Pointer to buffer for text height.

Returns:
  S_OK on success.

  Error code otherwise.

HRESULT IRnLibrary::GetSubLibrary | ( | [in] RtUlong | nIndex,
|  | [out, retval] IRnLibrary ** | pLibrary |
| ) |  |  |

Retrieves library on specified index.

Parameters:

  | nIndex | [In] Library index.
  | pLibrary | [Out] Library on index nIndex.

Returns:
  S_OK on success.

  Error code otherwise.

HRESULT IRnLibrary::GetLibraryItem | ( | [in] RtUlong | nIndex,
|  | [out] IRnLibraryItem ** | pLibraryItem |
| ) |  |  |

Retrieves library item on specified index.

Parameters:

  | nIndex | [In] Library item index.
  | pLibrary | [Out] Library item on index nIndex.

Returns:
  S_OK on success.

  Error code otherwise.

HRESULT IRnLibrary::GetLibrariesHeight | ( | [out, retval] RtUlong * | pVal | ) |

Retrieves library item on specified index.

Parameters:

  | nIndex | [In] Library item index.
  | pLibrary | [Out] Library item on index nIndex.

Returns:
  S_OK on success.

  Error code otherwise.

HRESULT IRnLibrary::AddItem | ( | [in] IRsNode * | pNode,
|  | [out, retval] IRnLibraryItem ** | lppItem |
| ) |  |  |

Retrieves object placed assigned to item.

Parameters:

  | pVal | [Out] Pointer to buffer for node pointer.

Returns:
  S_OK on success.

  Error code otherwise.

HRESULT IRnLibrary::AddLibrary | ( | [in] IRnLibrary * | pLibrary,
|  | [out, retval] IRnLibrary ** | lppLibrary |
| ) |  |  |

Retrieves object placed assigned to item.

Parameters:

  | pVal | [Out] Pointer to buffer for node pointer.

Returns:
  S_OK on success.

  Error code otherwise.

HRESULT IRnLibrary::ChangeLibraryIndex | ( | [in, out] RtUlong * | index,
|  | [in] IRnLibrary * | lpLibrary |
| ) |  |  |

Access to Library item type. Allows set Library item type.

Parameters:

  | newVal | [In] New type.

Returns:
  S_OK on success.

  Error code otherwise.

HRESULT IRnLibrary::ChangeLibraryItemIndex | ( | [in, out] RtUlong * | index,
|  | [in] IRnLibraryItem * | lpLibraryItem |
| ) |  |  |

Access to Library item type. Allows set Library item type.

Parameters:

  | newVal | [In] New type.

Returns:
  S_OK on success.

  Error code otherwise.

HRESULT IRnLibrary::GetCorrectLibraryItemName | ( | [in] IRnLibraryItem * | libraryItem,
|  | [in] BSTR | oldName,
|  | [out, retval] BSTR * | newName |
| ) |  |  |

Access to Library item type. Allows set Library item type.

Parameters:

  | newVal | [In] New type.

Returns:
  S_OK on success.

  Error code otherwise.

HRESULT IRnLibrary::CorrectLibraryItemName | ( | [in] IRnLibraryItem * | libraryItem,
|  | [out, retval] BSTR * | newName |
| ) |  |  |

Access to Library item type. Allows set Library item type.

Parameters:

  | newVal | [In] New type.

Returns:
  S_OK on success.

  Error code otherwise.

HRESULT IRnLibrary::SetAndSaveLocalSave | ( | [in] RtBool | bLocalSave | ) |

Access to Library item type. Allows set Library item type.

Parameters:

  | newVal | [In] New type.

Returns:
  S_OK on success.

  Error code otherwise.

HRESULT IRnLibrary::RestoreAfterExport | ( | void |  | ) |

Access to Library item type. Allows set Library item type.

Parameters:

  | newVal | [In] New type.

Returns:
  S_OK on success.

  Error code otherwise.

HRESULT IRnLibrary::PrepareForExport | ( | void |  | ) |

Access to Library item type. Allows set Library item type.

Parameters:

  | newVal | [In] New type.

Returns:
  S_OK on success.

  Error code otherwise.

HRESULT IRnLibrary::RestoreLocalSave | ( | void |  | ) |

Access to Library item type. Allows set Library item type.

Parameters:

  | newVal | [In] New type.

Returns:
  S_OK on success.

  Error code otherwise.

HRESULT IRnLibrary::StoreCurrentName | ( | void |  | ) |

Access to Library item type. Allows set Library item type.

Parameters:

  | newVal | [In] New type.

Returns:
  S_OK on success.

  Error code otherwise.

HRESULT IRnLibrary::ExportLibraryToFile | ( | [in] BSTR | bszFileName,
|  | [in] RtBool | bSaveItems |
| ) |  |  |

Access to Library item type. Allows set Library item type.

Parameters:

  | newVal | [In] New type.

Returns:
  S_OK on success.

  Error code otherwise.

HRESULT IRnLibrary::CanBeLocal | ( | [out] RtBool * | pResult | ) |

Access to Library item type. Allows set Library item type.

Parameters:

  | newVal | [In] New type.

Returns:
  S_OK on success.

  Error code otherwise.

HRESULT IRnLibrary::EnsureItemsPresence | ( | void |  | ) |

Ensure items presence.

Returns:
  S_OK on success.

  Error code otherwise.

HRESULT IRnLibrary::SaveAsLocal | ( | void |  | ) |

Access to Library item type. Allows set Library item type.

Parameters:

  | newVal | [In] New type.

Returns:
  S_OK on success.

  Error code otherwise.

HRESULT IRnLibrary::OnDeleteLibrary | ( | void |  | ) |

Called on delete of library.

Returns:
  S_OK on success.

  Error code otherwise.

HRESULT IRnLibrary::NameExists | ( | [in] BSTR | nameToCheck,
|  | [out] IRnLibrary ** | foundLibrary,
|  | [out] IRnLibraryItem ** | foundLibraryItem |
| ) |  |  |

Find subobject with given name.

Parameters:

  | nameToCheck | [In] Subobject's name to check.
  | foundLibrary | [Out] Pointer to library if subobject is a library.
  | foundLibraryItem | [Out] Pointer to library item if subobject is a library item.

Returns:
  S_OK on success.

  Error code otherwise.

## Property Documentation

BSTR* IRnLibrary::Name`[get]`

Access to Library item name. Allows retrieve Library item name.

Parameters:

  | pVal | [Out] Pointer to buffer for name.

Returns:
  S_OK on success.

  Error code otherwise.

BSTR IRnLibrary::Name`[set]`

Access to Library item name. Allows set Library item name.

Parameters:

  | newVal | [In] New name.

Returns:
  S_OK on success.

  Error code otherwise.

BSTR* IRnLibrary::HelpText`[get]`

Access to Library item help text (tool tip). Allows retrieve Library item help text.

Parameters:

  | pVal | [Out] Pointer to buffer for help text.

Returns:
  S_OK on success.

  Error code otherwise.

BSTR IRnLibrary::HelpText`[set]`

Access to Library item help text (tool tip). Allows set Library item help text.

Parameters:

  | newVal | [In] New help text.

Returns:
  S_OK on success.

  Error code otherwise.

HBITMAP* IRnLibrary::Bitmap([in] HDC hDC, [in] RtBool bPreview3D)`[get]`

Access to Library item bitmap handle.

Parameters:

  | bPreview3D | [In] Flag to retrieve bitmap for 2D or 3D aspect.
  | pVal | [Out] Pointer to buffer for bitmap handle.

Returns:
  S_OK on success.

  Error code otherwise.

RtUlong* IRnLibrary::Index`[get]`

Access to index of item. Allows retrieve value of index of item.

Parameters:

  | pVal | [Out] Pointer to buffer for index of item.

Returns:
  S_OK on success.

  Error code otherwise.

RtUlong IRnLibrary::Index`[set]`

Access to index of items. Allows set value of index.

Parameters:

  | newVal | [In] New index of items.

Returns:
  S_OK on success.

  Error code otherwise.

RtUlong IRnLibrary::ForcedIndex`[set]`

Access to index of library. Allows set value of library without futher notification.

Parameters:

  | newVal | [In] New index of library.

Returns:
  S_OK on success.

  Error code otherwise.

RtUlong* IRnLibrary::NumOfItems`[get]`

Access to number of items. Allows retrieve value of number of items.

Parameters:

  | pVal | [Out] Pointer to buffer for number of items.

Returns:
  S_OK on success.

  Error code otherwise.

RtUlong IRnLibrary::NumOfItems`[set]`

Access to number of items. Allows set value of number of items.

Parameters:

  | newVal | [In] New number of items.

Returns:
  S_OK on success.

  Error code otherwise.

RtUlong* IRnLibrary::NumOfSubLibraries`[get]`

Access to number of sub libraries. Allows retrieve value of number of sub libraries.

Parameters:

  | pVal | [Out] Pointer to buffer for number of sub libraries.

Returns:
  S_OK on success.

  Error code otherwise.

RtUlong* IRnLibrary::NumOfLibraryItems`[get]`

Access to number of library items. Allows retrieve value of number of library items.

Parameters:

  | pVal | [Out] Pointer to buffer for number of library items.

Returns:
  S_OK on success.

  Error code otherwise.

RtLibraryType* IRnLibrary::Type`[get]`

Access to Library item type. Allows retrieve Library item type.

Parameters:

  | pVal | [Out] Pointer to buffer for type.

Returns:
  S_OK on success.

  Error code otherwise.

RtLibraryType IRnLibrary::Type`[set]`

Access to Library item type. Allows set Library item type.

Parameters:

  | newVal | [In] New type.

Returns:
  S_OK on success.

  Error code otherwise.

RtUlong* IRnLibrary::LocalFlag`[get]`

Access to Library item type. Allows retrieve Library item type.

Parameters:

  | pVal | [Out] Pointer to buffer for type.

Returns:
  S_OK on success.

  Error code otherwise.

RtUlong IRnLibrary::LocalFlag`[set]`

Access to Library item type. Allows set Library item type.

Parameters:

  | newVal | [In] New type.

Returns:
  S_OK on success.

  Error code otherwise.

BSTR* IRnLibrary::LocalFileName`[get]`

Access to Library item name. Allows retrieve Library item name.

Parameters:

  | pVal | [Out] Pointer to buffer for name.

Returns:
  S_OK on success.

  Error code otherwise.

BSTR IRnLibrary::LocalFileName`[set]`

Access to Library item name. Allows set Library item name.

Parameters:

  | newVal | [In] New name.

Returns:
  S_OK on success.

  Error code otherwise.

BSTR* IRnLibrary::LocalPositionInGraph`[get]`

Access to Library item name. Allows retrieve Library item name.

Parameters:

  | pVal | [Out] Pointer to buffer for name.

Returns:
  S_OK on success.

  Error code otherwise.

BSTR IRnLibrary::LocalPositionInGraph`[set]`

Access to Library item name. Allows set Library item name.

Parameters:

  | newVal | [In] New name.

Returns:
  S_OK on success.

  Error code otherwise.

IRdBitmap** IRnLibrary::BmpObj`[get]`

Access to item preview bitmap data object.

Parameters:

  | ppVal | [Out] Pointer to buffer for bitmap data object.

Returns:
  S_OK on success.

  Error code otherwise.

IRdBitmap* IRnLibrary::BmpObj`[set]`

Access to item preview bitmap data object.

Parameters:

  | pVal | [In] Pointer to new bitmap data object.

Returns:
  S_OK on success.

  Error code otherwise.

IRdBitmap** IRnLibrary::SmallBmpObj`[get]`

Access to item preview small bitmap data object.

Parameters:

  | ppVal | [Out] Pointer to buffer for small bitmap data object.

Returns:
  S_OK on success.

  Error code otherwise.

IRdBitmap* IRnLibrary::SmallBmpObj`[set]`

Access to item preview small bitmap data object.

Parameters:

  | pVal | [In] Pointer to new small bitmap data object.

Returns:
  S_OK on success.

  Error code otherwise.

RtBool* IRnLibrary::IsPerformingLocalSaveOperations`[get]`

Access to Library item help text (tool tip). Allows retrieve Library item help text.

Parameters:

  | pVal | [Out] Pointer to buffer for help text.

Returns:
  S_OK on success.

  Error code otherwise.

RtBool* IRnLibrary::CustomLibraryBitmap`[get]`

Access to Library item type. Allows retrieve Library item type.

Parameters:

  | pVal | [Out] Pointer to buffer for type.

Returns:
  S_OK on success.

  Error code otherwise.

RtBool IRnLibrary::CustomLibraryBitmap`[set]`

Access to Library item type. Allows set Library item type.

Parameters:

  | newVal | [In] New type.

Returns:
  S_OK on success.

  Error code otherwise.

RtUlong* IRnLibrary::GroupId`[get]`

Access to group id of item.

Parameters:

  | pVal | [Out] Pointer to buffer for index of item.

Returns:
  S_OK on success.

  Error code otherwise.

RtUlong IRnLibrary::GroupId`[set]`

Access to group id of items.

Parameters:

  | newVal | [In] New index of items.

Returns:
  S_OK on success.

  Error code otherwise.